{% extends "./plantilla.html" %}
{% load static %}
{% block contenido %}
    <div class="container">
        <div class="row">
            <div class="col-md-6">
                <h1 class="text-center blanco-text">Nuevo Curso</h1>
                <form class="mb-4" action="/guardarCurso/" method="post" enctype="multipart/form-data" id="frm_nuevo_curs">
                    {% csrf_token %}
                    <div class="mb-3">
                        <label for="idCarreraBAFA" class="form-label blanco-text">Carrera:</label>
                        <select  name="carrera_id"  id="carrera_id" data-live-search="true" data-live-search-style="startsWith" class="selectpicker"required>
                            <option value="">--Seleccione La Carrera--</option>
                            {% for carrera in carreras %}
                                <option value="{{carrera.idCarreraBAFA}}">{{carrera.nombreCarreraBAFA}}</option>
                            {% endfor %}
                        </select>
                    </div>
                    <div class="mb-3">
                        <label for="nivelCursoBAFA" class="form-label blanco-text">Nivel del Curso:</label>
                        <input type="text" name="nivelCursoBAFA" id="nivelCursoBAFA" value="" class="form-control" placeholder="Ingrese el nivel de la carrera:" required>
                    </div>
                    <div class="mb-3">
                        <label for="descripcionCursoBAFA" class="form-label blanco-text">Ingrese la descripcion del Curso:</label>
                        <textarea name="descripcionCursoBAFA" id="descripcionCursoBAFA" cols="3" class="form-control" placeholder="Ingrese la descripcion del Curso:" required></textarea>
                    </div>
                    <div class="mb-3">
                        <label for="aulaCursoBAFA" class="form-label blanco-text">Ingrese el aula del Curso:</label>
                        <input type="text" name="aulaCursoBAFA" id="aulaCursoBAFA" value="" class="form-control" placeholder="Ingrese el aula del curso:" required>
                    </div>
                    <div class="mb-3">
                        <label for="fechaInicioBAFA" class="form-label blanco-text">Fecha de Inicio:</label>
                        <input type="date" name="fechaInicioBAFA" id="fechaInicioBAFA" value="" class="form-control" placeholder="Ingrese la fecha de Inicio" required>
                    </div>
                    <div class="mb-3">
                        <label for="profesorPrincipalBAFA" class="form-label blanco-text">Ingrese el nombre del Profesor:</label>
                        <input type="text" name="profesorPrincipalBAFA" id="profesorPrincipalBAFA" value="" class="form-control" placeholder="Ingrese el profesor Principal:" required>
                    </div>
                    <div class="text-center">
                        <button type="submit" name="button" class="btn btn-primary">Guardar</button>
                        <button type="reset" name="button" class="btn btn-danger">Cancelar</button>
                        <button id="toggleChartButton" onclick="toggleChart()" class="btn btn-info">Mostrar/ocultar gráfico</button>
                    </div>
                </form>
            </div>
            <div class="col-md-6">
                <h1 class="text-center blanco-text">LISTADO DE CURSOS</h1>
                <table class="table" id="tbl_curs">
                    <thead>
                        <tr>
                            <th>ID</th>
                            <th>NIVEL DEL CURSO</th>
                            <th>DESCRIPCION</th>
                            <th>AULA</th>
                            <th>FECHA DE INICIO</th>
                            <th>PROFESOR PRINCIPAL</th>
                            <th>CARRERA</th>
                            <th>ACCIONES</th>
                        </tr>
                    </thead>
                    <TBody>
                        {% for curso in cursos %}
                            <tr>
                                <td>{{ curso.idCursoBAFA }}</td>
                                <td>{{ curso.nivelCursoBAFA }}</td>
                                <td>{{ curso.descripcionCursoBAFA }}</td>
                                <td>{{ curso.aulaCursoBAFA }}</td>
                                <td>{{ curso.fechaInicioBAFA }}</td>
                                <td>{{ curso.profesorPrincipalBAFA }}</td>
                                <td>{{ curso.carrera.nombreCarreraBAFA }}</td>
                                <td>
                                    <a href="/editarCurso/{{ curso.idCursoBAFA }}" class="btn btn-warning">Editar</a>
                                    <a href="javascript:void(0)" class="btn btn-danger" onclick="eliminarCurso('/eliminarCurso/{{ curso.idCursoBAFA }}');">Borrar</a>
                                </td>
                            </tr>
                        {% endfor %}
                    </TBody>
                </table>
            </div>
        </div>
    </div>

    <script type="text/javascript">
        function eliminarCurso(url) {
            iziToast.question({
                timeout: 15000,
                close: true,
                overlay: true,
                displayMode: 'once',
                id: 'question',
                zindex: 999,
                title: 'CONFIRMACIÓN',
                message: '¿Está seguro de eliminar el Curso seleccionado?',
                position: 'center',
                buttons: [
                    ['<button><b>SI</b></button>', function (instance, toast) {
                        instance.hide({ transitionOut: 'fadeOut' }, toast, 'button');
                        window.location.href = url;
                    }, true],
                    ['<button>NO</button>', function (instance, toast) {
                        instance.hide({ transitionOut: 'fadeOut' }, toast, 'button');
                    }],
                ]
            });
        }
    </script>

    <script type="text/javascript">
        $("#frm_nuevo_curs").validate({
            rules:{
                "carrera_id": {
                    required: true
                },
                "nivelCursoBAFA":{
                    required: true
                },
                "descripcionCursoBAFA":{
                    required: true
                },
                "aulaCursoBAFA":{
                    required: true
                },
                "fechaInicioBAFA":{
                    required: true
                },
                "profesorPrincipalBAFA":{
                    required: true
                }
            },
            messages:{
                "carrera_id":{
                    required: "Por favor Seleccione una carrera"
                },
                "nivelCursoBAFA":{
                    required: "Debe ingresar un nivel de Curso"
                },
                "descripcionCursoBAFA":{
                    required: "Debe ingresar una Descripcion "
                },
                "aulaCursoBAFA":{
                    required: "Debe ingresar un aula Valida"
                },
                "fechaInicioBAFA":{
                    required: "Por favor ingrese una fecha de inicio"
                },
                "profesorPrincipalBAFA":{
                    required: "Debe ingresar un Profesor Principal"
                },
            }
        });
    </script>

    <script type="text/javascript">
           //let table = new DataTable('#tbl_clientes');
           $(document).ready(function() {
               $('#tbl_curs').DataTable({
                   dom: 'Bfrtip',
                   language: {
                     url: '//cdn.datatables.net/plug-ins/1.13.7/i18n/es-ES.json',
                   },
                   buttons: [
                       {
                           extend: 'pdfHtml5',
                           text: '<i class="fa fa-file-pdf-o"></i> PDF',
                           titleAttr: 'Exportar a PDF',
                           className: 'btn btn-danger', // Clase de estilo para el botón
                           title: 'LISTADO CURSOS'
                       },
                       {
                           extend: 'print',
                           text: '<i class="fa fa-print"></i> Imprimir',
                           titleAttr: 'Imprimir',
                           className: 'btn btn-primary' // Clase de estilo para el botón
                       },
                       {
                           extend: 'csv',
                           text: '<i class="fa fa-file-text-o"></i> CSV',
                           titleAttr: 'Exportar a CSV',
                           className: 'btn btn-success' // Clase de estilo para el botón
                       }
                   ]
               });
           });

          </script>

                <div id="chartContainer" style="width: 50%; margin: auto; border: 2px solid black; padding: 10px; display: none;">
                  <canvas id="myChart"></canvas>
                </div>

                <script>
                    document.addEventListener('DOMContentLoaded', function () {
                      const ctx = document.getElementById('myChart');

                      const carrerasSet = new Set();

                      const cursosCarrera = {};
                      {% for curso in cursos %}
                        carrerasSet.add("{{ curso.carrera.nombreCarreraBAFA }}");
                        if (!cursosCarrera["{{ curso.carrera.nombreCarreraBAFA }}"]) {
                          cursosCarrera["{{ curso.carrera.nombreCarreraBAFA }}"] = 1;
                        } else {
                          cursosCarrera["{{ curso.carrera.nombreCarreraBAFA }}"] += 1;
                        }
                      {% endfor %}
                      const carrerasArray = Array.from(carrerasSet);
                      const posiciones = carrerasArray.map((carrera, index) => ({ x: index, y: cursosCarrera[carrera] || 0 }));

                      new Chart(ctx, {
                        type: 'bar',
                        data: {
                          labels: carrerasArray,
                          datasets: [{
                            label: 'Cantidad de Carreras',
                            data: posiciones.map(posicion => posicion.y),
                            backgroundColor: 'rgba(192, 248, 248)',
                            borderColor: 'rgba(192, 248, 248)',
                            borderWidth: 1,
                          }]
                        },
                        options: {
                          scales: {
                            x: {
                              type: 'category',
                              position: 'bottom',
                            },
                            y: {
                              beginAtZero: true,
                              max: 10,
                              stepSize: 1,
                            }
                          }
                        }
                      });
                      window.toggleChart = function() {
                        const chartContainer = document.getElementById('chartContainer');

                        if (chartContainer.style.display === 'none') {
                          chartContainer.style.display = 'block';
                        } else {
                          chartContainer.style.display = 'none';
                        }
                      };
                    });

                </script>
{% endblock %}
